"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PageFooter = PageFooter;
const react_1 = __importDefault(require("react"));
const components_1 = require("@storybook/components");
const theming_1 = require("@storybook/theming");
const Paging_js_1 = require("./Paging.js");
const Container = (0, theming_1.withTheme)(theming_1.styled.div(({ theme }) => ({
    display: 'flex',
    padding: '20px',
    justifyContent: 'space-between',
    background: theme.background.content,
})));
const StyledButton = (0, theming_1.styled)(components_1.Button)({
    transform: 'none',
});
function PageFooter({ canApprove, retriesCount, retry, onRetryChange, onApprove, }) {
    return (react_1.default.createElement(Container, null,
        react_1.default.createElement(Paging_js_1.Paging, { activePage: retry, onPageChange: onRetryChange, pagesCount: retriesCount }),
        canApprove ? (react_1.default.createElement(StyledButton, { secondary: true, outline: true, onClick: onApprove }, 'Approve')) : null));
}
//# sourceMappingURL=PageFooter.js.map