"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SideBarHeader = SideBarHeader;
const react_1 = __importStar(require("react"));
const components_1 = require("@storybook/components");
const theming_1 = require("@storybook/theming");
const CreeveyContext_js_1 = require("../../CreeveyContext.js");
const TestsStatus_js_1 = require("./TestsStatus.js");
const Search_js_1 = require("./Search.js");
const Sticky = (0, theming_1.withTheme)(theming_1.styled.div(({ theme }) => ({
    padding: '24px 32px 8px',
    background: theme.background.content,
    height: '130px',
    zIndex: 5,
    position: 'sticky',
    top: '0',
})));
const Container = theming_1.styled.div({
    display: 'flex',
    justifyContent: 'space-between',
});
const Header = theming_1.styled.h2({
    fontWeight: 'normal',
    margin: 0,
});
const Button = (0, theming_1.withTheme)((0, theming_1.styled)(components_1.Button)(({ theme }) => ({
    display: 'flex',
    justifyContent: 'center',
    transform: 'none',
    width: '60px',
    padding: '8px 12px',
    '& svg': {
        width: '24px',
        height: '24px',
        marginRight: 0,
    },
    '&:active svg path': {
        fill: theme.color.inverseText,
    },
})));
const MarginContainer = theming_1.styled.div(({ left, right, top, bottom }) => ({
    marginLeft: left ?? 0,
    marginRight: right ?? 0,
    marginTop: top ?? 0,
    marginBottom: bottom ?? 0,
}));
const parseStringForFilter = (value) => {
    let status = null;
    const subStrings = [];
    const tokens = value
        .split(' ')
        .filter(Boolean)
        .map((word) => word.toLowerCase());
    tokens.forEach((word) => {
        const [, matchedStatus] = /^status:(failed|success|pending)$/i.exec(word) ?? [];
        if (matchedStatus)
            return (status = matchedStatus);
        subStrings.push(word);
    });
    return { status, subStrings };
};
function SideBarHeader({ testsStatus, onStop, onStart, filter, onFilterChange, canStart, }) {
    const { isReport, isRunning } = (0, react_1.useContext)(CreeveyContext_js_1.CreeveyContext);
    const [filterInput, setFilterInput] = (0, react_1.useState)('');
    const handleClickByStatus = (status) => {
        if (status === filter.status) {
            setFilterInput(filter.subStrings.join(' '));
            onFilterChange({ status: null, subStrings: filter.subStrings });
        }
        else {
            setFilterInput(filter.subStrings.join(' ') + ' status:' + status);
            onFilterChange({ status, subStrings: filter.subStrings });
        }
    };
    const handleInputFilterChange = (value) => {
        setFilterInput(value);
        onFilterChange(parseStringForFilter(value));
    };
    return (react_1.default.createElement(Sticky, null,
        react_1.default.createElement(Container, null,
            react_1.default.createElement("div", null,
                react_1.default.createElement(Header, null, "colin.creevey"),
                react_1.default.createElement(TestsStatus_js_1.TestsStatus, { ...testsStatus, onClickByStatus: handleClickByStatus })),
            isReport ? null : (react_1.default.createElement(MarginContainer, { top: "10px" }, isRunning ? (react_1.default.createElement(Button, { outline: true, secondary: true, onClick: onStop },
                react_1.default.createElement(components_1.Icons, { icon: "stop" }))) : (react_1.default.createElement(Button, { outline: true, secondary: true, onClick: onStart, disabled: !canStart },
                react_1.default.createElement(components_1.Icons, { icon: "play" })))))),
        react_1.default.createElement(MarginContainer, { top: "24px", bottom: "24px" },
            react_1.default.createElement(Search_js_1.Search, { onChange: handleInputFilterChange, value: filterInput }))));
}
//# sourceMappingURL=SideBarHeader.js.map