"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.test = exports.story = exports.kind = void 0;
exports.default = parse;
const api_1 = require("tsx/esm/api");
const csf_1 = require("@storybook/csf");
async function parse(files) {
    result = {};
    const unregister = (0, api_1.register)();
    await Promise.all(files.map(async (file) => {
        await import(file);
    }));
    await unregister();
    return result;
}
let result = {};
let kindTitle = '';
let storyTitle = '';
let storyParams = null;
const setStoryParameters = (params) => {
    storyParams = params;
};
const getStoryId = (kindTitle, storyTitle) => {
    return (0, csf_1.toId)(kindTitle, (0, csf_1.storyNameFromExport)(storyTitle));
};
const kind = (title, kindFn) => {
    kindTitle = title;
    kindFn();
    kindTitle = '';
};
exports.kind = kind;
const story = (title, storyFn) => {
    storyTitle = title;
    storyParams = null;
    storyFn({ setStoryParameters });
    const storyId = getStoryId(kindTitle, storyTitle);
    result[storyId] = Object.assign({}, storyParams, { tests: result[storyId]?.tests });
    storyTitle = '';
    storyParams = null;
};
exports.story = story;
const test = (title, testFn) => {
    const storyId = getStoryId(kindTitle, storyTitle);
    if (!result[storyId]) {
        result[storyId] = {};
    }
    result[storyId].tests = Object.assign({}, result[storyId].tests, { [title]: testFn });
};
exports.test = test;
//# sourceMappingURL=parser.js.map